import Foundation
import React
import FluentAdFlowAdsWidget

@objc(FluentAdFlowSdkManager)
class FluentAdFlowSdkManager: NSObject, RCTBridgeModule {
    static func moduleName() -> String {
        return "RNFluentAdFlowAdsSdk"
    }

    private let logTag = "FluentAdFlowSdkManager"
  
    // Initialize the SDK with an API key and referrer
    @objc(initSdk:withReferrer:)
    func initSdk(_ apiKey: String, referrer: String) {
        FluentAdFlowAdsSdk().initSdk(apiKey, withReferrer: referrer)
    }
  
  @objc func setParams(_ viewId: NSNumber, params: NSDictionary) {
      print("Bridge - viewId: \(viewId)")

      // Ensure execution on the UI thread
      DispatchQueue.main.async {
          guard
              let bridge = RCTBridge.current(),
              let uiManager = bridge.module(for: RCTUIManager.self) as? RCTUIManager
          else {
              return
          }
          
          // Access the view for the given viewId on the main thread
          if let fluentAdFlowWidgetView = uiManager.view(forReactTag: viewId) as? FluentAdFlowWidgetView {
              fluentAdFlowWidgetView.setParams(params)
          }
      }
  }



    @objc
    static func requiresMainQueueSetup() -> Bool {
        return true // Change this to true if UI-related work is being done
    }
}
